#include <os.h>
#include "utils.h"
#include "gfx.h"

inline uint8_t getFrighttime(uint8_t level){
    uint8_t frighttimes[20] = {6,5,4,3,2,5,2,2,1,5,2,1,1,3,1,1,0,1,0,0};
    return (level<21) ? frighttimes[level] : 0;
}

inline void setuint8array(uint8_t* array, uint8_t el0, uint8_t el1, uint8_t el2, uint8_t el3){
    array[0] = el0;
    array[1] = el1;
    array[2] = el2;
    array[3] = el3;
}

inline void setuint16array(uint16_t* array, uint16_t el0, uint16_t el1, uint16_t el2, uint16_t el3){
    array[0] = el0;
    array[1] = el1;
    array[2] = el2;
    array[3] = el3;
}

uint32_t frightenedtimeelapsed(uint32_t start){
    static uint32_t starttime;
    if(start)
        starttime = start;
    return *(uint32_t*)0x90090000 - starttime;
}

uint32_t elapsedtime(uint32_t start){
    static uint32_t starttime;
    if(start)
        starttime = start;
    return *(uint32_t*)0x90090000 - starttime;
}

void copyLevelbuf(uint8_t* scrbuf, uint8_t* levelbuf){
    int y;
    for(y=0;y<31*7;y++)
        memcpy((scrbuf + ((LEVEL_Y_OFFSET + y)*SCREEN_WIDTH/2) + LEVEL_X_OFFSET/2), (levelbuf + (y*SCREEN_WIDTH/2)), (28*7/2));
}

void drawLifes(uint8_t* scrbuf, uint8_t lifes){
    uint8_t i;
    putSprite(scrbuf, 0, LEVEL_X_OFFSET+lifes*14+4, LEVEL_Y_OFFSET+31*7, 0);
    for(i=0;i<lifes;i++){
        putSprite(scrbuf, 26, LEVEL_X_OFFSET+i*14+4, LEVEL_Y_OFFSET+31*7, 0x5);
    }
}

void drawScore(uint8_t* scrbuf, unsigned score){
    char scorestring[11];
    sprintf(scorestring,"%i",score);
    uint8_t i;
    for(i=0;scorestring[i] != '\0'; i++){
        putSprite(scrbuf,scorestring[i]-21,LEVEL_X_OFFSET+4+i*7,0,0x0);
    }
}

void printscr(uint8_t* scrbuf, unsigned num){
    char numstring[11];
    sprintf(numstring,"%i",num);
    uint8_t i;
    for(i=0;numstring[i] != '\0'; i++)
        putSprite(scrbuf,numstring[i]-21,i*7,0,0xB);
    putSprite(scrbuf,0,i*7,0,0xD);
}
